var LiamW = window.LiamW || {};
LiamW.CustomEditorColors = LiamW.CustomEditorColors || {};

!function ($, window, document, _undefined) {
    "use strict";

    LiamW.CustomEditorColors.HexColorPicker = XF.Element.extend('color-picker', {

        __backup: {
            'updatePickerData': '__updatePickerData'
        },

        updatePickerData: function (isMenuOpening) {
            console.log('ddd')
            var validMenuColor = this.getMenuColor(true),
                menuColor = this.getMenuColor();

            this.updatePickerSelections(validMenuColor);
            this.updateSelectedPropertyColor(menuColor);

            if (menuColor) {
                var colorRgb = menuColor.toRgb();
                this.menuEls.$input.val(('#' + ("00" + colorRgb['r'].toString(16)).substr(-2) + ("00" + colorRgb['g'].toString(16)).substr(-2) + ("00" + colorRgb['b'].toString(16)).substr(-2)).toUpperCase());
                this.menuEls.$previewCurrent.css('background-color', menuColor.toCss());
            }
            else {
                if (isMenuOpening) {
                    this.menuEls.$input.val('');
                }
                // if not opening, we don't have a valid value so we have to just leave it as is since they might be typing

                this.menuEls.$previewCurrent.css('background-color', '');
            }
        },

        setupMenu: function () {
            if (this.menuInited) {
                return;
            }
            this.menuInited = true;

            var $menu = this.getMenuEl();
            this.$box.after($menu);
            XF.activate($menu);

            this.menuEls.$propertyContainer = $menu.find('.colorPicker-propertyContainer');
            this.menuEls.$colorGrad = $menu.find('.colorPicker-colorGrad-color');
            this.menuEls.$colorGradIndicator = $menu.find('.colorPicker-colorGrad-indicator');
            this.menuEls.$hueBar = $menu.find('.colorPicker-hue-bar');
            this.menuEls.$hueIndicator = $menu.find('.colorPicker-hue-indicator');
            this.menuEls.$alphaBar = $menu.find('.colorPicker-alpha-bar');
            this.menuEls.$alphaIndicator = $menu.find('.colorPicker-alpha-indicator');
            this.menuEls.$previewOriginal = $menu.find('.colorPicker-preview-original');
            this.menuEls.$previewCurrent = $menu.find('.colorPicker-preview-current');
            this.menuEls.$input = $menu.find('.colorPicker-input');
            this.menuEls.$save = $menu.find('.colorPicker-save');

            this.menuEls.$propertyContainer.on('click', '[data-property]', $.proxy(this, 'propertyClick'));
            this.menuEls.$colorGrad.on('mousedown', $.proxy(this, 'colorGradMouseDown'));
            this.menuEls.$hueBar.on('mousedown', $.proxy(this, 'hueBarMouseDown'));
            this.menuEls.$alphaBar.on('mousedown', $.proxy(this, 'alphaBarMouseDown'));
            this.menuEls.$save.on('click', $.proxy(this, 'save'));

            $menu.find('.colorPicker-alpha').remove();
            $menu.find('.colorPicker-colorGrad').height(250);
            $menu.find('.colorPicker-colorGrad').width(250);

            this.menu = new XF.MenuClick(this.$box, {});
        }
    });

    XF.Editor = XF.extend(XF.Editor, {

        __backup: {
            'getEditorConfig': '__getEditorConfig'
        },

        getEditorConfig: function () {
            var config = this.__getEditorConfig();

            var customColors;

            try {
                customColors = $.parseJSON($('.js-liamw_customEditorColors').first().html()) || {};
                customColors = Object.values(customColors);
            }
            catch (e) {
                console.warn(e);
                customColors = {};
            }

            console.log(customColors);

            if (customColors.length > 0) {
                config.colorsText = customColors;
                config.colorsText.push("REMOVE");

                console.log(config.colorsText);

            } else {
                console.warn("No active custom editor colors defined. Falling back to default editor colors.")
            }

            return config;
        }
    });

}(jQuery, window, document);