<?php

namespace LiamW\CustomEditorColors\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class EditorColor extends Entity
{
	public function getCssHex()
	{
		return $this->color_hex ? '#' . $this->color_hex : '';
	}

	public function verifyColorHex(&$colorHex)
	{
		if (substr($colorHex, 0, 1) == '#')
		{
			$colorHex = substr($colorHex, 1);
		}

		return true;
	}

	public static function getStructure(Structure $structure)
	{
		$structure->table = 'xf_liamw_customeditorcolors_editor_color';
		$structure->shortName = 'LiamW\CustomEditorColors:EditorColor';

		$structure->primaryKey = 'color_hex';

		$structure->columns = [
			'color_hex' => [
				'type' => self::STR,
				'maxLength' => 6,
				'required' => true
			],
			'display_order' => [
				'type' => self::UINT,
				'default' => 10
			],
			'active' => [
				'type' => self::BOOL,
				'default' => true
			]
		];
		$structure->getters = [
			'css_hex' => true
		];

		return $structure;
	}

	protected function _postSave()
	{
		$this->repository('LiamW\CustomEditorColors:EditorColors')->rebuildEditorColorCache();
	}

	protected function _postDelete()
	{
		$this->repository('LiamW\CustomEditorColors:EditorColors')->rebuildEditorColorCache();
	}
}