<?php

namespace LiamW\CustomEditorColors\Repository;

use XF\Mvc\Entity\Repository;

class EditorColors extends Repository
{
	public function getEditorColorData()
	{
		$colorData = $this->finder('LiamW\CustomEditorColors:EditorColor')->where('active', 1)->order('display_order')
			->pluckFrom('css_hex')->fetch();

		$return = [];

		foreach ($colorData AS $colorDatum)
		{
			$return[] = $colorDatum;
		}

		return $return;
	}

	public function rebuildEditorColorCache(array $editorColors = null)
	{
		if ($editorColors === null)
		{
			$editorColors = $this->getEditorColorData();
		}

		$this->app()->simpleCache()->setValue('LiamW/CustomEditorColors', 'editorColors', $editorColors);

		return $editorColors;
	}
}