<?php

namespace LiamW\CustomEditorColors;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;
use XF\Db\Schema\Create;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUpgradeTrait;
	use StepRunnerUninstallTrait;

	public function installStep1()
	{
		$this->schemaManager()->createTable('xf_liamw_customeditorcolors_editor_color', function (Create $table) {
			$table->addColumn('color_hex', 'varchar', 6)->primaryKey();
			$table->addColumn('display_order', 'int')->setDefault(10);
			$table->addColumn('active', 'bool')->setDefault(1);
		});
	}

	public function installStep2()
	{
		$this->db()->insertBulk('xf_liamw_customeditorcolors_editor_color', [
			['color_hex' => '61BD6D', 'display_order' => 0],
			['color_hex' => '1ABC9C', 'display_order' => 10],
			['color_hex' => '54ACD2', 'display_order' => 20],
			['color_hex' => '2C82C9', 'display_order' => 30],
			['color_hex' => '9365B8', 'display_order' => 40],
			['color_hex' => '475577', 'display_order' => 50],
			['color_hex' => 'CCCCCC', 'display_order' => 60],
			['color_hex' => '41A85F', 'display_order' => 70],
			['color_hex' => '00A885', 'display_order' => 80],
			['color_hex' => '3D8EB9', 'display_order' => 90],
			['color_hex' => '2969B0', 'display_order' => 100],
			['color_hex' => '553982', 'display_order' => 110],
			['color_hex' => '28324E', 'display_order' => 120],
			['color_hex' => '000000', 'display_order' => 130],
			['color_hex' => 'F7DA64', 'display_order' => 140],
			['color_hex' => 'FBA026', 'display_order' => 150],
			['color_hex' => 'EB6B56', 'display_order' => 160],
			['color_hex' => 'E25041', 'display_order' => 170],
			['color_hex' => 'A38F84', 'display_order' => 180],
			['color_hex' => 'EFEFEF', 'display_order' => 190],
			['color_hex' => 'FFFFFF', 'display_order' => 200],
			['color_hex' => 'FAC51C', 'display_order' => 210],
			['color_hex' => 'F37934', 'display_order' => 220],
			['color_hex' => 'D14841', 'display_order' => 230],
			['color_hex' => 'B8312F', 'display_order' => 240],
			['color_hex' => '7C706B', 'display_order' => 250],
			['color_hex' => 'D1D5D8', 'display_order' => 260],
		]);
	}

	public function uninstallStep1()
	{
		$this->schemaManager()->dropTable('xf_liamw_customeditorcolors_editor_color');
	}
}